/*
 * (C) Copyright ParaSoft Corporation 2022.  All rights reserved.
 * THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF ParaSoft
 * The copyright notice above does not evidence any
 * actual or intended publication of such source code.
 */

#ifndef _INTERFACE_INFO_H
#define _INTERFACE_INFO_H

#include <stdlib.h>

struct InterfaceInfo
{
    int quality;
    int lowQuality;
    char* name;
    wchar_t* wname;
    wchar_t* wdescription;
    const char* prefix;
    bool isLoopBack;
    bool isCustom;
    bool hasMac;
    bool hasIp;
    unsigned char mac[6];
    unsigned char ip[4];

    InterfaceInfo() : quality(0), lowQuality(0), name(0), wname(0), wdescription(0), prefix(0), isLoopBack(false), isCustom(false), hasMac(false), hasIp(false)
    {
        for (int i = 0; i < 6; ++i) {
            mac[i] = 0;
        }
        for (int i = 0; i < 4; ++i) {
            ip[i] = 0;
        }
    }

    ~InterfaceInfo()
    {
        if (name) {
            free(name);
        }
        if (wname) {
            free(wname);
        }
        if (wdescription) {
            free(wdescription);
        }
    }
};

#endif
