/*
 * $RCSfile: Environment.cc,v $
 * $Revision: 1.5 $
 *
 * Comments:
 *
 * (C) Copyright ParaSoft Corporation 1996.  All rights reserved.
 * THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF ParaSoft
 * The copyright notice above does not evidence any
 * actual or intended publication of such source code.
 *
 * $Author: dario $          $Locker:  $
 * $Date: 2005-11-21 12:09:22 $
 * $Log: not supported by cvs2svn $
 * Revision 1.4  2005/11/21 11:39:45  dario
 * getEnvironment added.
 *
 * Revision 1.3  2005/11/17 11:37:56  dario
 * syntex fixed.
 *
 * Revision 1.2  2005/11/17 10:12:32  dario
 * setenv added.
 *
 * Revision 1.1  2005/11/15 11:50:07  jez
 * New file.
 *
 */
 
#include "Environment.h"

#include <stdlib.h>
#include <stdio.h>


static int length(const char* str)
{
	int count = 0;
	while (*(str + count) != 0) {
		count ++;
	}	
	return count;
}

static void strcpy(char* dest, const char* source)
{
    int count = 0;
    while (*(source + count) != 0) {
        dest[count] = source[count];
        count ++;
    }
    dest[count] = 0;
}

const  char * Environment::getenv(const char * name)
{
    return ::getenv(name);
}

void Environment::setenv(const char* name, const char* value)
{
	// name=value null terminated
	int size = length(name) + 1 + length(value) + 1;
	
    char *env = new char[size];
    sprintf (env, "%s=%s", name, value);
    ::putenv (env);  /*putenv now owns the malloc'd memory */ 
}

extern char** environ;
char** Environment::getEnvironment(int& count)
{
	count = 0;
	while (environ[count]) {
	    count++;   
	}
	
	char** result = new char*[count];
	for (int i = 0; i < count; i++) {
		int len = length(environ[i]);
	    result[i] = new char[len + 1];
	    strcpy(result[i], environ[i]);
	}
	return result;
}

