<?xml version="1.0"?>

<!-- in case of any change in xsl/xml file modify all connected xsl and xml files from this package  -->
<xsl:stylesheet version="1.1" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:saxon="http://icl.com/saxon" xmlns:graph="graph"
    extension-element-prefixes="saxon" xmlns:file="file" xmlns:textutil="textutil">
	<xsl:param name="base_font">Arial</xsl:param>
	
	<xsl:param name="header_font_size">18px</xsl:param>
	<xsl:param name="small_header_font_size">18px</xsl:param>
	<xsl:param name="code_font_size">12px</xsl:param>
	<xsl:param name="base_font_size">12px</xsl:param>
	<xsl:param name="time_font_size">11px</xsl:param>
	
    <xsl:variable name="counter">0</xsl:variable>
	<xsl:param name="exec_cvg_details_type">LC</xsl:param>
	<xsl:param name="report_format_mode">html</xsl:param>
	<xsl:param name="RES_PARAMETER_NO_EXECUTABLE_LINES">No coverable items</xsl:param>	
	<xsl:param name="RES_PARAMETER_PARASOFT"> </xsl:param>
	<xsl:param name="RES_PARAMETER_NOT_AVAILABLE"> </xsl:param>
	<xsl:param name="RES_PARAMETER_REPORTIMNG_SYSTEM"> </xsl:param>
	<xsl:param name="RES_PARAMETER_COVERAGE_SUMMARY"> </xsl:param>
	<xsl:param name="RES_PARAMETER_DOCUMENT_FOR_FRAMES">This document is designed to be viewed using the frames feature</xsl:param>
	<xsl:param name="RES_PARAMETER_IF_YOU_SEE_MESSAGE">If you see this message, you are using a non-frame-capable web client</xsl:param>	
	<xsl:param name="RES_PARAMETER_TEST_EXECUTION_COVERAGE_REPORT">Test Execution Coverage Report</xsl:param>
	<xsl:param name="RES_PARAMETER_TEST_EXECUTION_COVERAGE_REPORT_MENU">Test Execution Coverage Report: Menu</xsl:param>	
	<xsl:param name="RES_PARAMETER_TEST_EXECUTION_COVERAGE_REPORT_UPPERCASE">TEST EXECUTION COVERAGE REPORT</xsl:param>	
	<xsl:param name="RES_PARAMETER_PLEASU_USE_FRAME">Please use frame-capable web client</xsl:param>
	<xsl:param name="RES_PARAMETER_LINES_COVERED_PART1">Code with the following background color:</xsl:param>
	<xsl:param name="RES_PARAMETER_LINES_COVERED_PART2_1">has been covered/tested</xsl:param>
	<xsl:param name="RES_PARAMETER_LINES_COVERED_PART2_2">has not been covered/tested</xsl:param>
	<xsl:param name="RES_PARAMETER_LINES_COVERED_PART2_2_2">has been partially covered/tested</xsl:param>
	<xsl:param name="RES_PARAMETER_LINES_COVERED_PART2_3">has no coverable elements</xsl:param>	 	
	<xsl:param name="report_type">disk_report</xsl:param>
	<xsl:param name="details">true</xsl:param>	
	<xsl:param name="show_lines">true</xsl:param>	
	<xsl:param name="output_dir">D:\secondary\eclipse_runtime\plugins\XSL_DEVEL\</xsl:param>
	<xsl:param name="header_img"/>
    <xsl:param name="header_exp_img"/>
    <xsl:param name="header_logo_img"/>
	<xsl:variable name="status_covered" select="2"/>
	<xsl:variable name="status_not_covered" select="1"/>
	<xsl:variable name="status_not_coverable" select="0"/>
	<xsl:variable name="toolName" select="/ResultsSession/@toolName"/>	
	<xsl:variable name="toolDispName">
		<xsl:choose>
			<xsl:when test="/ResultsSession/@toolDispName">
				<xsl:value-of select="/ResultsSession/@toolDispName"/>
			</xsl:when>
			<xsl:otherwise>
				<xsl:value-of select="/ResultsSession/@toolName"/>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:variable>
	<xsl:variable name="toolVer" select="/ResultsSession/@toolVer"/>
	<xsl:variable name="disk_report">disk_report</xsl:variable> 
	<xsl:variable name="tcm_report">tcm_report</xsl:variable>   
	<xsl:variable name="email_report">email_report</xsl:variable>
	<xsl:variable name="time" select="/ResultsSession/@time" saxon:assignable="yes"/>
	<xsl:variable name="cur_project" saxon:assignable="yes"/>
	<xsl:variable name="cur_package" saxon:assignable="yes"/>	
	<xsl:variable name="nbsp" select="concat('&amp;','#xA0;')"/>
	<xsl:variable name="copy" select="concat('&amp;','copy;')"/>
	<xsl:variable name="reg" select="concat('&amp;','reg;')"/>
	<xsl:variable name="qt">"</xsl:variable>
	<xsl:param name="width">95%</xsl:param>
	<xsl:variable name="ju_bcolor">#F3F3F3</xsl:variable>
	<xsl:variable name="ju_bdrcolor">#CBCBCB</xsl:variable>
	<xsl:variable name="exec_bcolor">#F3F3F3</xsl:variable>
	<xsl:variable name="exec_bdrcolor">#CBCBCB</xsl:variable>	
<!--	<xsl:variable name="exec_sym_cvg" select="count(/ResultsSession/Exec/Coverage/SymCvg)"/?>-->
	<xsl:variable name="exec_res_cvg" select="count(/ResultsSession/Exec/Coverage/CvgStats)"/>
	<xsl:variable name="cvg_files" select="count(/ResultsSession/Exec/Coverage/CvgStats/CvgInfo/CvgInfo)"/>
	<xsl:variable name="menu_frame">menu</xsl:variable>
	<xsl:variable name="src_frame">src</xsl:variable>
	<xsl:variable name="covered_char">code</xsl:variable>
	<xsl:variable name="ncovered_char">code</xsl:variable>
	<xsl:variable name="hcovered_char">code</xsl:variable>
	<xsl:variable name="covered_ruler_char">.</xsl:variable>
	<xsl:variable name="hcovered_ruler_char">.</xsl:variable>
	<xsl:variable name="ncovered_ruler_char" select="concat('&amp;','gt;')"/>
	<xsl:variable name="covered">#99ff99</xsl:variable>
	<xsl:variable name="ncovered">#ffcccc</xsl:variable>
	<xsl:variable name="hcovered">#ffff66</xsl:variable>	
	<xsl:variable name="neither">#ffffff</xsl:variable>
	<xsl:variable name="blueborder_color">#A0CAEC</xsl:variable>
    <xsl:variable name="body_color">#E7F0F5</xsl:variable>
    <xsl:variable name="footer_color">#1D488D</xsl:variable>	
	
	<xsl:variable name="style_covered">covered</xsl:variable>
	<xsl:variable name="style_ncovered">notcovered</xsl:variable>
	<xsl:variable name="style_hcovered">halfcovered</xsl:variable>
	<xsl:variable name="style_neither">neither</xsl:variable>
	
	<xsl:variable name="styles"> BODY,P,OL,TD{font-family: <xsl:value-of select="$base_font"/>, Helvetica, sans-serif;font-size:
		<xsl:value-of select="$base_font_size"/>;font-style: normal;color: #000000;} A:link {font-family: <xsl:value-of select="$base_font"/>, Helvetica,
		sans-serif;font-style: normal;color: #990000;text-decoration: none;} A:active {font-family:
		Arial, Helvetica, sans-serif;font-style: normal;color: #990000;text-decoration: none;}
		A:visited {font-family: <xsl:value-of select="$base_font"/>, Helvetica, sans-serif;font-style: normal;color:
		#999999;text-decoration: none;} A:hover {font-family: <xsl:value-of select="$base_font"/>, Helvetica,
		sans-serif;font-style: normal;color: #990000;text-decoration: underline;} A.gray_link:link
		{font-family: sans-serif;font-size: <xsl:value-of select="$base_font_size"/>;color: #666666;text-decoration: none;}
		A.gray_link:active {font-family: sans-serif;font-size: <xsl:value-of select="$base_font_size"/>;color: #666666;text-decoration:
		none;} A.gray_link:visited {font-family: sans-serif;font-size: <xsl:value-of select="$base_font_size"/>;color:
		#666666;text-decoration: none;} A.gray_link:hover {font-family: sans-serif;font-size:
		<xsl:value-of select="$base_font_size"/>;color: #666666;text-decoration: underline;} A.red_link:link {font-family:
		sans-serif;font-size: <xsl:value-of select="$base_font_size"/>;color: #990000;text-decoration: none;} A.red_link:active
		{font-family: sans-serif;font-size: <xsl:value-of select="$base_font_size"/>;color: #990000;text-decoration: none;}
		A.red_link:visited {font-family: sans-serif;font-size: <xsl:value-of select="$base_font_size"/>;color: #990000;text-decoration:
		none;} A.red_link:hover {font-family: sans-serif;font-size: <xsl:value-of select="$base_font_size"/>;color:
		#990000;text-decoration: underline;} A.green_link:link {font-family: sans-serif;font-size:
		<xsl:value-of select="$base_font_size"/>;color: #008040;text-decoration: none;} A.green_link:active {font-family:
		sans-serif;font-size: <xsl:value-of select="$base_font_size"/>;color: #008040;text-decoration: none;} A.green_link:visited
		{font-family: sans-serif;font-size: <xsl:value-of select="$base_font_size"/>;color: #008040;text-decoration: none;}
		A.green_link:hover {font-family: sans-serif;font-size: <xsl:value-of select="$base_font_size"/>;color: #008040;text-decoration:	underline;} 
		A.black_link:link {font-family: sans-serif;font-size: <xsl:value-of select="$base_font_size"/>;color: #000000;text-decoration: none;} 
		A.black_link:active {font-family: sans-serif;font-size: <xsl:value-of select="$base_font_size"/>;color: #000000;text-decoration: none;} 
		A.black_link:visited {font-family: sans-serif;font-size: <xsl:value-of select="$base_font_size"/>;color: #000000;text-decoration: none;} 
		A.black_link:hover {font-family: sans-serif;font-size: <xsl:value-of select="$base_font_size"/>;color: #000000;text-decoration: underline;}
		A.blue_link:link {font-family: sans-serif;font-size: <xsl:value-of select="$base_font_size"/>;color: #0000FF;text-decoration: none;} 
        A.blue_link:active {font-family: sans-serif;font-size: <xsl:value-of select="$base_font_size"/>;color: #0000FF;text-decoration: none;} 
        A.blue_link:visited {font-family: sans-serif;font-size: <xsl:value-of select="$base_font_size"/>;color: #0000FF;text-decoration: none;} 
        A.blue_link:hover {font-family: sans-serif;font-size: <xsl:value-of select="$base_font_size"/>;color: #0000FF;text-decoration: underline;}
        A.dark_blue_link:link {font-family: sans-serif;font-size: <xsl:value-of select="$base_font_size"/>;color: #00008B;text-decoration: none;} 
        A.dark_blue_link:active {font-family: sans-serif;font-size: <xsl:value-of select="$base_font_size"/>;color: #00008B;text-decoration: none;} 
        A.dark_blue_link:visited {font-family: sans-serif;font-size: <xsl:value-of select="$base_font_size"/>;color: #00008B;text-decoration: none;} 
        A.dark_blue_link:hover {font-family: sans-serif;font-size: <xsl:value-of select="$base_font_size"/>;color: #00008B;text-decoration: underline;}		
		A.gray_red_link:link {font-family: sans-serif;font-size: <xsl:value-of select="$base_font_size"/>;color:
		#666666;text-decoration: none;} A.gray_red_link:active {font-family: sans-serif;font-size:
		<xsl:value-of select="$base_font_size"/>;color: #666666;text-decoration: none;} A.gray_red_link:visited {font-family:
		sans-serif;font-size: <xsl:value-of select="$base_font_size"/>;color: #666666;text-decoration: none;} A.gray_red_link:hover
		{font-family: sans-serif;font-size: <xsl:value-of select="$base_font_size"/>;color: #666666;text-decoration: none;} FONT.gray
		{font-size: <xsl:value-of select="$base_font_size"/>;font-family: <xsl:value-of select="$base_font"/>, Helvetica, sans-serif;color: #999999;} FONT.gray2,
		FONT.gray_red {font-size: <xsl:value-of select="$base_font_size"/>;font-family: <xsl:value-of select="$base_font"/>, Helvetica, sans-serif;color: #666666;}
		FONT.time {font-size: <xsl:value-of select="$time_font_size"/>;font-family: <xsl:value-of select="$base_font"/>, Helvetica, sans-serif;color: #000000;}
        TABLE.singleborder{ border:1px solid <xsl:value-of select="$ju_bdrcolor"/>}
        TABLE.doubleborder{ border:2px solid <xsl:value-of select="$ju_bdrcolor"/>}
	TABLE.singleborder_blue{ border:2px solid #427fb6}
        TD.singleborder{ border:1px solid <xsl:value-of select="$ju_bdrcolor"/>}
	DIV.header{font-size: <xsl:value-of select="$header_font_size"/>; FONT-FAMILY: <xsl:value-of select="$base_font"/>, Helvetica, sans-serif; COLOR: #427fb6 }
    	DIV.small_header{font-size: <xsl:value-of select="$small_header_font_size"/>; FONT-FAMILY: <xsl:value-of select="$base_font"/>, Helvetica, sans-serif; COLOR: #427fb6 }    
		FONT.covered {font-size: <xsl:value-of select="$code_font_size"/>;font-family: "Courier New", Courier, monospace; background-color: #99ff99;}
		FONT.notcovered {font-size: <xsl:value-of select="$code_font_size"/>;font-family: "Courier New", Courier, monospace; background-color: #ffcccc;}
		FONT.halfcovered {font-size: <xsl:value-of select="$code_font_size"/>;font-family: "Courier New", Courier, monospace; background-color: #ffff66;}		
		FONT.neither {font-size: <xsl:value-of select="$code_font_size"/>;font-family: "Courier New", Courier, monospace; background-color: #ffffff;}
		
		FONT.code     {font-size: <xsl:value-of select="$code_font_size"/>;font-family: "Courier New", Courier, monospace; background-color: #ffffff;}
		
		FONT.white {font-size: <xsl:value-of select="$base_font_size"/>;font-family: <xsl:value-of select="$base_font"/>, Helvetica, sans-serif;color: #FFFFFF;}
		FONT.red {font-size:<xsl:value-of select="$base_font_size"/>;font-family: <xsl:value-of select="$base_font"/>, Helvetica, sans-serif;color: #990000;}
		FONT.red2 {font-size:<xsl:value-of select="$base_font_size"/>;font-family: <xsl:value-of select="$base_font"/>, Helvetica, sans-serif;color: #990000;
		text-decoration: underline;} FONT.green {font-size:<xsl:value-of select="$base_font_size"/>;font-family: <xsl:value-of select="$base_font"/>, Helvetica,
		sans-serif;color: #008040;} FONT.small {font-size: 1px;font-family: <xsl:value-of select="$base_font"/>, Helvetica,
		sans-serif;color: #cccccc;} SELECT.cs_authors {font-family: <xsl:value-of select="$base_font"/>, Helvetica,
		sans-serif;font-size: <xsl:value-of select="$base_font_size"/>;} SELECT.ju_authors {font-family: <xsl:value-of select="$base_font"/>, Helvetica,
		sans-serif;font-size: <xsl:value-of select="$base_font_size"/>;} TD.cs_authors{font-family: <xsl:value-of select="$base_font"/>, Helvetica,
		sans-serif;font-size: <xsl:value-of select="$base_font_size"/>;font-style: normal;color: #000000;border: 1px; bordercolor:
		#d9c8ac;} UL, LI {font-family: <xsl:value-of select="$base_font"/>, Helvetica, sans-serif;font-size: <xsl:value-of select="$base_font_size"/>;font-style:
		normal;color: #000000; list-style-type: none; margin: 0; padding-left: 12px;}
		#foldheader{cursor:pointer;cursor:hand ;} </xsl:variable>
	
	<xsl:variable name="displayTree">
		var ns6=document.getElementById &amp;&amp; !document.all
		var ie4=document.all &amp;&amp; navigator.userAgent.indexOf("Opera")==-1
		
		var lastLocation = "";
        function openLocation(location)
        {
            if (lastLocation != location) {
                parent.src.location = location;
                lastLocation = location;
            }
        }
		
		function checkcontained(e){
		var iscontained=0
		cur=ns6? e.target : event.srcElement
		i=0
		if (cur.id=="foldheader")
		iscontained=1
		else
		while (ns6 &amp;&amp; cur.parentNode || (ie4 &amp;&amp; cur.parentElement)){
		if (cur.id=="foldheader"||cur.id=="foldinglist"){
		iscontained=(cur.id=="foldheader")? 1 : 0
		break
		}
		cur=ns6? cur.parentNode : cur.parentElement
		}
		
		if (iscontained){
		var foldercontent=ns6? cur.nextSibling.nextSibling : cur['nextSibling']
		if (foldercontent.style.display=="none"){
		foldercontent.style.display=""
		}
		else{
		foldercontent.style.display="none"
		}
		}
		}
		
		if (ie4||ns6)
		document.onclick=checkcontained
	</xsl:variable>
    
    <saxon:function name="file:exist">
        <xsl:param name="path"/>
        <xsl:variable name="file_exist" select="textutil:fileExist($path)"/>
        <saxon:return select="$file_exist"/>
    </saxon:function>

    <!-- =================  print ju coverage item ============================ -->
    <xsl:template name="coverage_file">
        <xsl:param name="file_loc"/>
        <xsl:param name="fileName"/>
        <xsl:param name="file_html"/>
        <xsl:param name="coveragePercentage"/>
        <xsl:param name="coveredItems"/>
        <xsl:param name="totalItems"/>

        <xsl:variable name="main_node" select="/ResultsSession/Exec/Coverage/Files/File[@loc=$file_loc]"/>
        <xsl:variable name="cvgPrtTemp" select="$main_node/@val"/>
        <xsl:variable name="cvgItemsTemp" select="$main_node/@num"/>
        <xsl:variable name="totItemsTemp" select="$main_node/@total"/>
        <xsl:variable name="file_nameTemp" select="$main_node/@loc"/>
        
        <xsl:variable name="cvgPrt">
            <xsl:choose>
                <xsl:when test="$cvgPrtTemp != ''">
                    <xsl:value-of select="$cvgPrtTemp"/>
                </xsl:when>
                <xsl:otherwise>
                    <xsl:value-of select="$coveragePercentage"/>
                </xsl:otherwise>
            </xsl:choose>
        </xsl:variable>
        
        <xsl:variable name="cvgItems">
            <xsl:choose>
                <xsl:when test="$cvgItemsTemp != ''">
                    <xsl:value-of select="$cvgItemsTemp"/>
                </xsl:when>
                <xsl:otherwise>
                    <xsl:value-of select="$coveredItems"/>
                </xsl:otherwise>
            </xsl:choose>
        </xsl:variable>
        
        <xsl:variable name="totItems">
            <xsl:choose>
                <xsl:when test="$totItemsTemp != ''">
                    <xsl:value-of select="$totItemsTemp"/>
                </xsl:when>
                <xsl:otherwise>
                    <xsl:value-of select="$totalItems"/>
                </xsl:otherwise>
            </xsl:choose>
        </xsl:variable>
        
        <xsl:variable name="file_name">
            <xsl:choose>
                <xsl:when test="$file_nameTemp != ''">
                    <xsl:value-of select="$file_nameTemp"/>
                </xsl:when>
                <xsl:otherwise>
                    <xsl:value-of select="$fileName"/>
                </xsl:otherwise>
            </xsl:choose>
        </xsl:variable>
        
        <xsl:variable name="cvg_decor_type" select="/ResultsSession/Exec/Coverage/Types/CvgType[@id=$main_node/CvgData/@cvgType]/@cvgDecor"/>
        <xsl:variable name="fileExist" select="file:exist($file_html)"></xsl:variable>
        <xsl:choose>
            <xsl:when test="not($fileExist)">
                <xsl:document href="{$file_html}">
                    <html>
                        <head>
                            <style type="text/css">
                                <xsl:value-of select="($styles)"/>
                            </style>
                            <title>
                                <xsl:if test="($totItems) > 0">
                  [<b>
                                        <xsl:value-of select="($cvgPrt)"/>%
                  </b><xsl:value-of select="($nbsp)"
                                        disable-output-escaping="yes"/>
                                    <xsl:value-of select="($cvgItems)"/>/<xsl:value-of select="($totItems)"/>
                                    <xsl:value-of select="($nbsp)" disable-output-escaping="yes"/>]
                  <xsl:value-of select="($nbsp)"
                                        disable-output-escaping="yes"/>
                                    <xsl:value-of select="($nbsp)" disable-output-escaping="yes"/>
                                    <xsl:value-of select="($file_loc)"/>
                                </xsl:if>
                                <xsl:if test="not(($totItems) > 0)">
                  [<xsl:value-of select="$RES_PARAMETER_NO_EXECUTABLE_LINES"
                                        />]
                  <xsl:value-of select="($nbsp)" disable-output-escaping="yes"/>
                                    <xsl:value-of select="($nbsp)" disable-output-escaping="yes"/>
                                    <xsl:value-of select="($nbsp)" disable-output-escaping="yes"/>
                                    <xsl:value-of select="($file_name)"/>
                                </xsl:if>
                                <!--						<xsl:value-of select="($file_loc)"/> -->
                            </title>
                        </head>
                        <body bgcolor="{$body_color}">                        	
                            <!-- file header -->
                            <xsl:call-template name="header_image">
                                <xsl:with-param name="file_html" select="($file_html)"/>
                            </xsl:call-template>
                            <br/>
                            <xsl:call-template name="file_header">
                                <xsl:with-param name="file_name" select="($file_loc)"/>
                            </xsl:call-template>
                            <br/>
                            <!-- coverage legend -->
                            <xsl:value-of select="($nbsp)" disable-output-escaping="yes"/>
                            <xsl:value-of select="$RES_PARAMETER_LINES_COVERED_PART1"/>
                            <table border="0" width="80%" cellpadding="0" cellspacing="3">
                                <tr>
                                    <td align="center" bgcolor="{$covered}" width="10">
                                        <xsl:if test="($cvg_decor_type) = 'ruler'">
                                            <font class="covered"><xsl:value-of select="($covered_ruler_char)" disable-output-escaping="yes"/></font>
                                        </xsl:if>
                                        <xsl:if test="not(($cvg_decor_type) = 'ruler')">
                                            <font class="covered"><xsl:value-of select="($covered_char)" disable-output-escaping="yes"/></font>
                                        </xsl:if>
                                    </td>
                                    <td>
                                        <xsl:value-of select="$RES_PARAMETER_LINES_COVERED_PART2_1"/>
                                    </td>
                                </tr>
                                <xsl:if test="not(($toolName) = 'dotTEST')">
                                    <tr>
                                        <td align="center" bgcolor="{$ncovered}" width="10">
                                            <xsl:if test="($cvg_decor_type) = 'ruler'">
                                                <font class="notcovered"><xsl:value-of select="($ncovered_ruler_char)" disable-output-escaping="yes"/></font>
                                            </xsl:if>
                                            <xsl:if test="not(($cvg_decor_type) = 'ruler')">
                                                <font class="notcovered"><xsl:value-of select="($ncovered_char)" disable-output-escaping="yes"/></font>
                                            </xsl:if>
                                        </td>
                                        <td>
                                            <xsl:value-of select="$RES_PARAMETER_LINES_COVERED_PART2_2"/>
                                        </td>
                                    </tr>
                                </xsl:if>
                                <xsl:if test="not(($toolName) = 'dotTEST')">
                                    <tr>
                                        <td align="center" bgcolor="{$hcovered}" width="10">
                                            <xsl:if test="($cvg_decor_type) = 'ruler'">
                                                <font class="halfcovered"><xsl:value-of select="($hcovered_ruler_char)" disable-output-escaping="yes"/></font>
                                            </xsl:if>
                                            <xsl:if test="not(($cvg_decor_type) = 'ruler')">
                                                <font class="halfcovered"><xsl:value-of select="($hcovered_char)" disable-output-escaping="yes"/></font>
                                            </xsl:if>
                                        </td>
                                        <td>
                                            <xsl:value-of select="$RES_PARAMETER_LINES_COVERED_PART2_2_2"/>
                                        </td>
                                    </tr>
                                </xsl:if>

                                <xsl:if test="not(($toolName) = 'dotTEST')">
                                    <tr>
                                        <td align="center" bgcolor="{$neither}" width="10">
                                            <xsl:if test="($cvg_decor_type) = 'ruler'">
                                               <font class="neither"><xsl:value-of select="($nbsp)" disable-output-escaping="yes"/></font>
                                            </xsl:if>
                                            <xsl:if test="not(($cvg_decor_type) = 'ruler')">
                                               <font class="neither">code</font>
                                            </xsl:if>
                                        </td>
                                        <td>
                                            <xsl:value-of select="$RES_PARAMETER_LINES_COVERED_PART2_3"/>
                                        </td>
                                    </tr>
                                </xsl:if>
                            </table>
                            <br/>
                            <!-- coverage file source -->
                            
                            <table class="singleborder_blue" width='100%' cellpadding='0' cellspacing='0' bgcolor="#FFFFFF" bordercolor="{$blueborder_color}">
                                <tr>
                                    <td>

                                        <table width="100%" border="0" cellpadding="0" cellspacing="1">

                                            <tr>
                                                <td align="center" colspan="4">
                                                    <xsl:if test="($totItems) > 0">
                                                        <xsl:value-of select="($cvgPrt)"/>% 
                                                        [<xsl:value-of select="($nbsp)" disable-output-escaping="yes"/>
                                                        <xsl:value-of select="($cvgItems)"/>/<xsl:value-of select="($totItems)"/>
                                                        <xsl:value-of select="($nbsp)" disable-output-escaping="yes"/>
                                                        ]
                                                        <xsl:value-of select="($nbsp)" disable-output-escaping="yes"/>
                                                        <xsl:value-of select="($nbsp)" disable-output-escaping="yes"/>
                                                        <xsl:value-of select="($file_name)"/>
                                                    </xsl:if>
                                                    <xsl:if test="not(($totItems) > 0)">
                                                       [<xsl:value-of select="$RES_PARAMETER_NO_EXECUTABLE_LINES"/>]
                                                        <xsl:value-of select="($nbsp)" disable-output-escaping="yes"/>
                                                        <xsl:value-of select="($nbsp)" disable-output-escaping="yes"/>
                                                        <xsl:value-of select="($nbsp)" disable-output-escaping="yes"/>
                                                        <xsl:value-of select="($file_name)"/>
                                                    </xsl:if>
                                                    <xsl:variable name="counter" select="($counter + 1)"/>
                                                </td>
                                            </tr>
                                            <tr>
                                                <xsl:if test="($cvg_decor_type) = 'ruler'">
                                                    <td valign="top">
                                                        <table border="0" cellpadding="0" cellspacing="0" width="100%">
                                                            <tr>
                                                                <td valign="top">
                                                                    <pre><code>
                                                    <xsl:variable name="contentLines" select="textutil:getLines($main_node/Content, 'true')"/>
                                                    <xsl:variable name="contentLinesSize" select="textutil:getLinesSize($contentLines)"/>
                                                               
                                                    <xsl:call-template name="process_contents_ruler">
                                                       <xsl:with-param name="contentLines" select="$contentLines"/>
                                                       <xsl:with-param name="lineStatuses" select="textutil:getLineStatuses($main_node/CvgData/Stat/@val, $main_node/CvgData/Lines/@val, $contentLinesSize)"/>
                                                       <xsl:with-param name="currLine" select="1"/>
                                                       <xsl:with-param name="contentLinesSize" select="$contentLinesSize"/>
                                                    </xsl:call-template>
                                                                   </code></pre>
                                                               </td>
                                                            </tr>
                                                        </table>
                                                    </td>
                                                    <td>
                                                        <xsl:value-of select="($nbsp)" disable-output-escaping="yes"/>
                                                    </td>
                                                </xsl:if>
                                                <xsl:if test="($cvg_decor_type) = 'marker'">
                                                    <td>
                                                        <xsl:value-of select="($nbsp)" disable-output-escaping="yes"/>
                                                    </td>
                                                    <td valign="top">
                                                        <table border="0" cellpadding="0" cellspacing="0" width="100%">
                                                            <tr>
                                                                <td valign="top">
                                                                    <pre><code>
                                                        <xsl:variable name="lineEndOffsets" select="textutil:getLineEndOffsets($main_node/Content, 'true')"/>

                                                        <xsl:call-template name="process_contents">
                                                           <xsl:with-param name="contents" select="$main_node/Content"/>
                                                           <xsl:with-param name="statuses" select="$main_node/CvgData/Stat/@val"/>
                                                           <xsl:with-param name="offsets" select="substring-after(($main_node/CvgData/Off/@val),';')"/>
                                                           <xsl:with-param name="position" select="0"/>
                                                           <xsl:with-param name="lineEndOffsets" select="$lineEndOffsets"/>
                                                           <xsl:with-param name="currLine" select="1"/>
                                                           <xsl:with-param name="displayLineNumber">true</xsl:with-param>
	                                                       <xsl:with-param name="maxLineIndentation" select="string-length(textutil:getLinesSize($lineEndOffsets)) + 1"/>
                                                       </xsl:call-template>
                                                                    </code></pre>
                                                                </td>
                                                            </tr>
                                                        </table>
                                                    </td>
                                                    <td>
                                                        <xsl:value-of select="($nbsp)" disable-output-escaping="yes"/>
                                                    </td>
                                                </xsl:if>

                                            </tr>
                                        </table>
                                    </td>
                                </tr>
                            </table>
                            <br/>
                            <br/>
                            <xsl:call-template name="footer"/>                            
                        </body>
                    </html>
                </xsl:document>
            </xsl:when>
            <xsl:otherwise>
                <!-- File was already created. Do not recreate it. -->
            </xsl:otherwise>
        </xsl:choose>
    </xsl:template>

<!-- =================  recursively output file ruler markers, painting the coverage ============================ -->

<xsl:template name="add_ruler_line">
	<xsl:param name="currLine"/>
	<xsl:param name="line"/>
	<xsl:param name="status"/>
	<xsl:param name="contentLinesSize"/>

		<xsl:variable name="lchar" select="$nbsp" saxon:assignable="yes"/>
		<xsl:variable name="style" saxon:assignable="yes">code</xsl:variable>
	
		<xsl:if test="$status=3">
			<saxon:assign name="lchar" select="$covered_ruler_char"/>
			<saxon:assign name="style" select="$style_covered"/>
		</xsl:if>
		<xsl:if test="$status=1">
			<saxon:assign name="lchar" select="$ncovered_ruler_char"/>
			<saxon:assign name="style" select="$style_ncovered"/>
		</xsl:if>
		<xsl:if test="$status=2">
			<saxon:assign name="lchar" select="$hcovered_ruler_char"/>
			<saxon:assign name="style" select="$style_hcovered"/>
		</xsl:if>
		
        <xsl:if test="$style = 'code'">
	      <font class="{$style}"><xsl:call-template name="print_line_number">
             <xsl:with-param name="line" select="$currLine"/>
             <xsl:with-param name="maxLineIndentation" select="string-length($contentLinesSize + 1) + 1"/>
           </xsl:call-template><xsl:value-of select="$lchar" disable-output-escaping="yes"/><xsl:value-of select="($nbsp)" disable-output-escaping="yes"/><xsl:value-of select="$line"/></font>
        </xsl:if>
        <xsl:if test="not($style = 'code')">
	      <font class="code"><xsl:call-template name="print_line_number">
             <xsl:with-param name="line" select="$currLine"/>
             <xsl:with-param name="maxLineIndentation" select="string-length($contentLinesSize + 1) + 1"/>
          </xsl:call-template></font><font class="{$style}"><xsl:value-of select="$lchar" disable-output-escaping="yes"/></font><font class="code"><xsl:value-of select="($nbsp)" disable-output-escaping="yes"/><xsl:value-of select="$line"/></font>
        </xsl:if>

</xsl:template>

<xsl:template name="process_contents_ruler">
	<xsl:param name="contentLines"/>
	<xsl:param name="lineStatuses"/>
	<xsl:param name="currLine"/>
	<xsl:param name="contentLinesSize"/>
	
	<xsl:if test="$contentLinesSize > ($currLine - 1)">

       <xsl:call-template name="add_ruler_line">
	      <xsl:with-param name="currLine" select="$currLine"/>
	      <xsl:with-param name="line" select="textutil:getLine($contentLines, $currLine - 1)"/>
	      <xsl:with-param name="status" select="textutil:getLineStatus($lineStatuses, $currLine - 1)"/>
		  <xsl:with-param name="contentLinesSize" select="$contentLinesSize"/>
	   </xsl:call-template>

	   <xsl:call-template name="process_contents_ruler">
          <xsl:with-param name="contentLines" select="$contentLines"/>
		  <xsl:with-param name="lineStatuses" select="$lineStatuses"/>
	      <xsl:with-param name="currLine" select="$currLine + 1"/>
		  <xsl:with-param name="contentLinesSize" select="$contentLinesSize"/>
	   </xsl:call-template>	
	</xsl:if>
</xsl:template>	

<!-- =================  recursively output file contents, painting the coverage ============================ -->
<xsl:template name="process_contents">
	<xsl:param name="contents"/>
	<xsl:param name="statuses"/>
	<xsl:param name="offsets"/>
	<xsl:param name="position"/>
	<xsl:param name="lineEndOffsets"/>
    <xsl:param name="currLine"/>
    <xsl:param name="displayLineNumber"/>
    <xsl:param name="maxLineIndentation"/>
    
	
	<xsl:variable name="offset" select="substring-before(($offsets),';')" saxon:assignable="yes"/>
	<xsl:variable name="rest_offsets" select="substring-after(($offsets),';')" saxon:assignable="yes"/>

	<xsl:if test="not(string-length($offset) > 0)">
		<xsl:if test="string-length($offsets) > 0">
			<saxon:assign name="offset" select="$offsets"/>
		</xsl:if>
		<xsl:if test="string-length($offsets) = 0">
			<saxon:assign name="offset" select="string-length($contents)"/>
		</xsl:if>
	</xsl:if>

	<xsl:variable name="endLineOffset" select="textutil:getIntValue($lineEndOffsets, $currLine - 1)" saxon:assignable="yes"/>
	<xsl:if test="not(($endLineOffset) > 0)">
		<saxon:assign name="endLineOffset" select="$offset"/>
    </xsl:if>

	<xsl:variable name="status" select="substring-before(($statuses),';')"/>
	<xsl:variable name="rest_status" select="substring-after(($statuses),';')" saxon:assignable="yes"/>

	<xsl:variable name="nextLine" select="$currLine" saxon:assignable="yes"/>
	<xsl:variable name="nextDisplayLineNumber" saxon:assignable="yes">false</xsl:variable>
	<xsl:variable name="currentPosition" select="$offset" saxon:assignable="yes"/>

	<xsl:if test="$offset > $endLineOffset">
    	<saxon:assign name="nextLine" select="$currLine + 1"/>
    	<saxon:assign name="nextDisplayLineNumber">true</saxon:assign>
    	<saxon:assign name="currentPosition" select="$endLineOffset"/>

    	<saxon:assign name="rest_offsets" select="$offsets"/>
    	<saxon:assign name="rest_status" select="$statuses"/>
	</xsl:if>
	<xsl:if test="$endLineOffset = $offset">
    	<saxon:assign name="nextLine" select="$currLine + 1"/>
    	<saxon:assign name="nextDisplayLineNumber">true</saxon:assign>
	</xsl:if>

	<xsl:variable name="current_content" select="substring(($contents), $position + 1, $currentPosition - $position)"/>
	
	<xsl:variable name="style" saxon:assignable="yes">code</xsl:variable>
	
	<xsl:if test="$status=3">
		<saxon:assign name="style" select="$style_covered"/>
	</xsl:if>
	<xsl:if test="$status=1">
		<saxon:assign name="style" select="$style_ncovered"/>
	</xsl:if>
	<xsl:if test="$status=2">
		<saxon:assign name="style" select="$style_hcovered"/>
	</xsl:if>

	<xsl:if test="$displayLineNumber = 'true'">

       <xsl:if test="$style = 'code'">
	      <font class="{$style}"><xsl:call-template name="print_line_number">
           <xsl:with-param name="line" select="$currLine"/>
           <xsl:with-param name="maxLineIndentation" select="$maxLineIndentation"/>
       </xsl:call-template><xsl:value-of select="$current_content"/></font>
       </xsl:if>
       <xsl:if test="not($style = 'code')">
	   <font class="code"><xsl:call-template name="print_line_number">
           <xsl:with-param name="line" select="$currLine"/>
           <xsl:with-param name="maxLineIndentation" select="$maxLineIndentation"/>
       </xsl:call-template></font><font class="{$style}"><xsl:value-of select="$current_content"/></font>
       </xsl:if>
    </xsl:if>

	<xsl:if test="not($displayLineNumber = 'true')">      
       <font class="{$style}"><xsl:value-of select="$current_content"/></font>
	</xsl:if>
	
	<xsl:if test="string-length($contents) > $currentPosition">
		<xsl:call-template name="process_contents">
			<xsl:with-param name="contents" select="$contents"/>
			<xsl:with-param name="statuses" select="$rest_status"/>
			<xsl:with-param name="offsets" select="$rest_offsets"/>
			<xsl:with-param name="position" select="$currentPosition"/>
			<xsl:with-param name="lineEndOffsets" select="$lineEndOffsets"/>
	        <xsl:with-param name="currLine" select="$nextLine"/>
	        <xsl:with-param name="displayLineNumber" select="$nextDisplayLineNumber"/>
	        <xsl:with-param name="maxLineIndentation" select="$maxLineIndentation"/>
		</xsl:call-template>
	</xsl:if>
	
</xsl:template>

	<xsl:template name="print_line_number">
	    <xsl:param name="line"/>
    	<xsl:param name="maxLineIndentation"/>
    
	    <xsl:if test="($show_lines) = 'true'">
        	<xsl:variable name="idx" saxon:assignable="yes">0</xsl:variable>
        	<xsl:variable name="indent" select="$maxLineIndentation - string-length($line)"/>
            <saxon:while test="$indent > $idx">
            <saxon:assign name="idx" select="$idx+1"/>
            <xsl:value-of select="($nbsp)" disable-output-escaping="yes"/>                        
            </saxon:while></xsl:if><xsl:value-of 
        select="$line"/><xsl:value-of select="($nbsp)" disable-output-escaping="yes"/>
    </xsl:template>

	<!-- =================  print footer ============================ -->
	<xsl:template name="footer">
		<xsl:variable name="os_name" select="root/properties/property[@name='os.name']/@value"/>
		<table width="100%" bgcolor="{$footer_color}" border='0' bordercolor='#999999' cellpadding='10' cellspacing='0'>
			<tr>
				<td align="center">
					<font class="white">
					<xsl:value-of select="($copy)" disable-output-escaping="yes"/><xsl:value-of select="$RES_PARAMETER_PARASOFT"/>
					<xsl:value-of select="($toolDispName)" disable-output-escaping="yes"/>
					<xsl:value-of select="($reg)" disable-output-escaping="yes"/>
					<xsl:value-of select="($nbsp)" disable-output-escaping="yes"/>
					<xsl:value-of select="($toolVer)"/>
					<xsl:value-of select="($nbsp)" disable-output-escaping="yes"/>
					<xsl:value-of select="$RES_PARAMETER_REPORTIMNG_SYSTEM"/><xsl:value-of
						select="($nbsp)" disable-output-escaping="yes"/>
					<xsl:if test="string-length($os_name) > 0">
						<font class="gray2"> OS: <xsl:value-of select="($os_name)"/>
						</font>
					</xsl:if>
				</font> 
				</td>
			</tr>
		</table>
	</xsl:template>
	
	<!-- =================  print file_header ============================ -->
	<xsl:template name="file_header">			
		<xsl:param name="file_name"/>
		<table width="100%" border="0" bordercolor="#999999" cellpadding="0" cellspacing="0">
			<tr>				
				<td align="center">
					<xsl:value-of select="($file_name)"/>
				</td>
			</tr>
			<tr>
			<td width="16%" align="center">
				<font class="time">
					<xsl:value-of select="($time)"/>
				</font>
			</td>
			</tr>
		</table>
	</xsl:template>

    <!-- =============== generate header ============== -->

    <xsl:template name="header_image">
    <xsl:param name="file_html"/>
    <xsl:variable name="res_img" saxon:assignable="yes"></xsl:variable>
    <saxon:assign name="res_img" 
        select="graph:publishFor($file_html,$header_exp_img)"/>
    <saxon:assign name="res_img" 
	    select="graph:publishFor($file_html,$header_logo_img)"/>
    <saxon:assign name="res_img" 
        select="graph:publishFor($file_html,$header_img)"/>
        
    <table width="100%" cellpadding="0" cellspacing="0"><tr>
    <xsl:call-template name="img_background">
    <xsl:with-param name="bkg" select="($header_exp_img)"/>
    <xsl:with-param name="src" select="($header_logo_img)"/>   
    <xsl:with-param name="alt" select="($header_logo_img)"/>
    <xsl:with-param name="width">20%</xsl:with-param>
    <xsl:with-param name="align">left</xsl:with-param>
    </xsl:call-template>
    <xsl:call-template name="img_background">
    <xsl:with-param name="bkg" select="($header_exp_img)"/>
    <xsl:with-param name="src" select="($header_img)"/>   
    <xsl:with-param name="alt" select="($header_img)"/>
    <xsl:with-param name="width">40%</xsl:with-param>
    <xsl:with-param name="align">center</xsl:with-param>
    </xsl:call-template>
    <xsl:call-template name="img_background">
    <xsl:with-param name="bkg" select="($header_exp_img)"/>    
    <xsl:with-param name="width">20%</xsl:with-param>
    <xsl:with-param name="align">right</xsl:with-param>
    </xsl:call-template>    
    </tr></table>
    </xsl:template>
    
    <!-- =============== img_background ============== -->
    
    <xsl:template name="img_background">
    <xsl:param name="bkg"/>
    <xsl:param name="src"/>
    <xsl:param name="alt"/>
    <xsl:param name="width"/>
    <xsl:param name="align"/>
    
    <td background="{$bkg}" width="{$width}" align="{$align}">
    <xsl:if test="$src">
    	<img src="{$src}" alt="{$alt}"/>
    </xsl:if>
    </td>
    </xsl:template>

	<!-- =================  print ju coverage summary and authors errors  ============================ -->
	<xsl:template name="coverage_menu">
		<table width='100%' border='0' bordercolor='{$exec_bdrcolor}' cellpadding='0' cellspacing='0'>		
			<tr>
				<td>
					
					<table width="100%" border="0" bordercolor="#999999" cellpadding="0" cellspacing="0">
						<tr>						
							<td align="center" nowrap="true">
								<div class="small_header"><xsl:value-of select="$RES_PARAMETER_COVERAGE_SUMMARY"/></div>
							</td>
						</tr>
					</table>
				</td>			
			</tr>
						<tr>
							<td>
								<table class="doubleborder" width="100%" bordercolor="{$ju_bdrcolor}" cellpadding="0" cellspacing="0">
									<tr>
										<td>
											<div id="cov_res" style="display:block;">
												<xsl:if test="($exec_res_cvg) > 0">
													<xsl:for-each select="/ResultsSession/Exec/Coverage/CvgStats/CvgInfo">
														<xsl:call-template name="coverage_items">
															<xsl:with-param name="depth">0</xsl:with-param>
														</xsl:call-template>
													</xsl:for-each>
												</xsl:if>
												<xsl:if test="not(($exec_res_cvg) > 0)">
													<xsl:value-of select="$RES_PARAMETER_NOT_AVAILABLE"/>
												</xsl:if>										
											</div>
										</td>
									</tr>
								</table>
							</td>
						</tr>											
		</table>
	</xsl:template>	
	
	
	
	<!-- ==============  Start to generate menu html   ====================  -->
	
	<xsl:template name="menu_template">
	<xsl:variable name="file_html"
		select="concat($output_dir,'menu.html')"/>	
	<xsl:document href="{$file_html}">	
		<html>
			<head>
				<style type="text/css">
            <xsl:value-of select="($styles)"/>
          </style>
                    <title>
                    	<div class="header"><xsl:value-of select="$RES_PARAMETER_TEST_EXECUTION_COVERAGE_REPORT_MENU"/>[<xsl:value-of select="($time)"/>]</div>                        
          			</title>

                    <script language="JavaScript">
            <xsl:value-of select="($displayTree)"/>
          </script>
			</head>
			
			<body bgcolor="{$body_color}">
				<br/>
				<table class="singleborder_blue" width='95%' cellpadding='7' cellspacing='0' bgcolor="#FFFFFF" bordercolor="{$blueborder_color}">
				<tr>
				<td>
					<xsl:call-template name="menu_header"/>
					<br/>
					<xsl:call-template name="coverage_menu"/>
				</td>
				</tr>
				</table>
				<br/>
			</body>
		</html>
		
		<xsl:if test="($cvg_files) > 0">			
			<!--<xsl:for-each
				select="/Results/Exec/Coverage/Files/File">
				<xsl:call-template name="coverage_file">
					<xsl:with-param name="file" select="@loc"/>					
				</xsl:call-template>
			</xsl:for-each>-->
						
		</xsl:if>
	</xsl:document>
	</xsl:template>
	
	<!-- =================  print menu_header ============================ -->
	<xsl:template name="menu_header">
		<table width="100%" border="0" bordercolor="#999999" cellpadding="0" cellspacing="0">
			<tr>
				<!--
					<td width="16%" align="center">
					<font class="time"><xsl:value-of select="($time)"/></font>
					</td>
				-->
				<td align="center" nowrap="true">
				    <div class="small_header"><xsl:value-of select="$RES_PARAMETER_TEST_EXECUTION_COVERAGE_REPORT_UPPERCASE"/></div>
				</td>
			</tr>
		</table>
	</xsl:template>
	
	<!-- =================  generate frame page ============================ -->
	<xsl:output method="html"/>
	<xsl:template match="/">
		<xsl:call-template name="menu_template"/>
		<xsl:variable name="first_file_loc"	select="/ResultsSession/Exec/Coverage/CvgStats//CvgInfo[@loc][1]/@loc" saxon:assignable="yes"/>		
		<saxon:assign name="first_file_loc" select="substring-after(($first_file_loc),'/')"/>
		<saxon:assign name="first_file_loc" select="concat($first_file_loc,'.html')"/>		
			<html>
				<head>
					<style type="text/css">
                    <xsl:value-of select="($styles)"/>
                </style>
					<title> <xsl:value-of select="$RES_PARAMETER_TEST_EXECUTION_COVERAGE_REPORT"/> [<xsl:value-of select="($time)"/>]
                 </title>
            </head>

            <frameset cols="25%,65%">
                <frame src="menu.html" name="{$menu_frame}"/>
                <xsl:element name="frame">
                    <xsl:attribute saxon:disable-output-escaping="yes" name="src">
                        <xsl:value-of select="$first_file_loc"/>
                    </xsl:attribute>
                    <xsl:attribute name="name">
                        <xsl:value-of select="$src_frame"/>
                    </xsl:attribute>
                </xsl:element>
            </frameset>

            <noframes>
                <table class="singleborder" width="80%" cellpadding="0" cellspacing="0" bordercolor="#999999">
                    <tr>
                        <td class="singleborder" align="center" bgcolor="{$ju_bcolor}">
                            <xsl:value-of select="$RES_PARAMETER_PLEASU_USE_FRAME"/>
                        </td>
                    </tr>
                    <tr>
                        <td class="singleborder">
                            <xsl:value-of select="$RES_PARAMETER_DOCUMENT_FOR_FRAMES"/>
                        </td>
                    </tr>
                    <tr>
                        <td class="singleborder">
                            <xsl:value-of select="$RES_PARAMETER_IF_YOU_SEE_MESSAGE"/>
                        </td>
                    </tr>
                </table>
            </noframes>

        </html>

    </xsl:template>

    <!-- =============== standard_link_ref ============== -->
    <xsl:template name="standard_link_ref">
        <xsl:param name="href"/>
        <xsl:param name="label"/>
        <xsl:param name="class"/>
        <xsl:param name="id"/>
        <xsl:param name="email_class"/>
        <xsl:if test="($report_type) = ($disk_report) or ($report_type) = ($tcm_report)">
            <xsl:if test="not(string-length($id) > 0)">
                <a class="{$class}" href="{$href}">
                    <xsl:value-of select="($label)"/>
                </a>
            </xsl:if>
            <xsl:if test="(string-length($id) > 0)">
                <a id="{$id}" class="{$class}" href="{$href}">
                    <xsl:value-of select="($label)"/>
                </a>
            </xsl:if>
        </xsl:if>

        <xsl:if test="($report_type) = ($email_report)">
            <xsl:if test="not(string-length($email_class) > 0)">
                <xsl:variable name="class_id" select="substring-before($class,'_link')"/>
                <font class="{$class_id}">
                    <xsl:value-of select="($label)"/>
                </font>
            </xsl:if>
            <xsl:if test="string-length($email_class) > 0">
                <font class="{$email_class}">
                    <xsl:value-of select="($label)"/>
                </font>
            </xsl:if>
        </xsl:if>
    </xsl:template>

    <!-- =================  print exec coverage items ============================ -->
    <xsl:template name="coverage_items">
        <xsl:param name="depth"/>
        <xsl:call-template name="coverage_item">
            <xsl:with-param name="name" select="@elem"/>
            <xsl:with-param name="percentValues" select="@val"/>
            <xsl:with-param name="coveredValues" select="@num"/>
            <xsl:with-param name="totalValues" select="@total"/>
            <xsl:with-param name="location" select="@loc"/>
            <xsl:with-param name="children" select="count(./CvgInfo)"/>
        </xsl:call-template>
        <xsl:if test="not(($depth) > 0)">
            <ul id="foldinglist">
                <xsl:for-each select="./CvgInfo">
                    <xsl:call-template name="coverage_items">
                        <xsl:with-param name="depth" select="$depth + 1"/>
                    </xsl:call-template>
                </xsl:for-each>
            </ul>
        </xsl:if>
        <xsl:if test="($depth) > 0">
            <ul id="foldinglist" style="display:none">
                <xsl:for-each select="./CvgInfo">
                    <xsl:call-template name="coverage_items">
                        <xsl:with-param name="depth" select="$depth + 1"/>
                    </xsl:call-template>
                </xsl:for-each>
            </ul>
        </xsl:if>
    </xsl:template>

    <!-- =================  print exec coverage item ============================ -->
    <xsl:template name="coverage_item">
        <xsl:param name="name"/>
        <xsl:param name="percentValues"/>
        <xsl:param name="coveredValues"/>
        <xsl:param name="totalValues"/>
        <xsl:param name="location"/>
        <xsl:param name="children"/>
        <xsl:variable name="li_id" saxon:assignable="yes">foldheader</xsl:variable>
        <xsl:variable name="percentVals" saxon:assignable="yes" select="$percentValues"/>
        <xsl:variable name="coveredVals" saxon:assignable="yes" select="$coveredValues"/>
        <xsl:variable name="totalVals" saxon:assignable="yes" select="$totalValues"/>
        <xsl:if test="not(($children) > 0) or ($report_type = $email_report)">
            <saxon:assign name="li_id">item</saxon:assign>
        </xsl:if>

        <li id="{$li_id}">
            <xsl:if test="not($report_type = $email_report) and ($children) > 0">
                <font color="{$exec_bcolor}">+</font>
            </xsl:if>
            <xsl:if test="not($report_type = $email_report) and ($children) = 0">
                <xsl:value-of select="($nbsp)" disable-output-escaping="yes"/>
            </xsl:if>

            <xsl:variable name="cvgPrt" saxon:assignable="yes"/>
            <xsl:variable name="cvgItems" saxon:assignable="yes"/>
            <xsl:variable name="totItems" saxon:assignable="yes"/>

            <xsl:for-each select="/ResultsSession/Exec/Coverage/Types/CvgType">
                <xsl:variable name="percentValue" select="substring-before(($percentVals),';')" saxon:assignable="yes"/>
                <xsl:if test="not(string-length($percentValue) > 0)">
                    <saxon:assign name="percentValue" select="$percentVals"/>
                </xsl:if>
                <saxon:assign name="percentVals" select="substring-after(($percentVals),';')"/>

                <xsl:variable name="coveredValue" select="substring-before(($coveredVals),';')" saxon:assignable="yes"/>
                <xsl:if test="not(string-length($coveredValue) > 0)">
                    <saxon:assign name="coveredValue" select="$coveredVals"/>
                </xsl:if>
                <saxon:assign name="coveredVals" select="substring-after(($coveredVals),';')"/>

                <xsl:variable name="totalValue" select="substring-before(($totalVals),';')" saxon:assignable="yes"/>
                <xsl:if test="not(string-length($totalValue) > 0)">
                    <saxon:assign name="totalValue" select="$totalVals"/>
                </xsl:if>
                <saxon:assign name="totalVals" select="substring-after(($totalVals),';')"/>

                <xsl:if test="@id = $exec_cvg_details_type">
                    <saxon:assign name="cvgPrt" select="$percentValue"/>
                    <saxon:assign name="cvgItems" select="$coveredValue"/>
                    <saxon:assign name="totItems" select="$totalValue"/>
                </xsl:if>
            </xsl:for-each>

            <xsl:variable name="file_relative_url" select="substring-after(($location),'/')" saxon:assignable="yes"/>
            <saxon:assign name="file_relative_url" select="concat($file_relative_url,'.html')"/>
            <xsl:variable name="file_full_url" select="concat($output_dir,$file_relative_url)" saxon:assignable="yes"/>
            <saxon:assign name="file_full_url" select="translate($file_full_url, '\','/')"/>

            <xsl:if test="string-length($location) > 0">
                <xsl:call-template name="coverage_file">
                    <xsl:with-param name="file_loc" select="$location"/>
                    <xsl:with-param name="fileName" select="$name"/>
                    <xsl:with-param name="file_html" select="$file_full_url"/>
                    <xsl:with-param name="coveragePercentage" select="$cvgPrt"/>
                    <xsl:with-param name="coveredItems" select="$cvgItems"/>
                    <xsl:with-param name="totalItems" select="$totItems"/>
                </xsl:call-template>
            </xsl:if>
            <xsl:if test="($totItems) > 0">
                <xsl:if test="not(($details) = 'true') or not(string-length($location) > 0)">
          [<b>
                        <xsl:value-of select="($cvgPrt)"/>%
          </b><xsl:value-of select="($nbsp)" disable-output-escaping="yes"/>
                    <xsl:value-of select="($cvgItems)"/>/<xsl:value-of select="($totItems)"/>
                    <xsl:value-of select="($nbsp)" disable-output-escaping="yes"/>]
          <xsl:value-of select="($nbsp)"
                        disable-output-escaping="yes"/><xsl:value-of select="($nbsp)" disable-output-escaping="yes"/>
                    <xsl:value-of select="($name)"/>
                </xsl:if>
                <xsl:if test="(($details) = 'true') and (string-length($location) > 0)">
                    <xsl:element name="a">
                        <xsl:attribute name="class">dark_blue_link</xsl:attribute>
                        <xsl:attribute saxon:disable-output-escaping="yes" name="href">
              javascript:openLocation('<xsl:value-of
                                select="($file_relative_url)"/>')
            </xsl:attribute>

            [<b>
                            <xsl:value-of select="($cvgPrt)"/>%
            </b><xsl:value-of select="($nbsp)" disable-output-escaping="yes"/>
                        <xsl:value-of select="($cvgItems)"/>/<xsl:value-of select="($totItems)"/>
                        <xsl:value-of select="($nbsp)" disable-output-escaping="yes"/>]
            <xsl:value-of select="($nbsp)"
                            disable-output-escaping="yes"/><xsl:value-of select="($nbsp)" disable-output-escaping="yes"/>
                        <xsl:value-of select="($name)"/>
                    </xsl:element>
                </xsl:if>
            </xsl:if>
            <xsl:if test="not(($totItems) > 0)">
        [<xsl:value-of select="$RES_PARAMETER_NO_EXECUTABLE_LINES"/>]
        <xsl:value-of
                    select="($nbsp)" disable-output-escaping="yes"/>
                <xsl:value-of select="($nbsp)" disable-output-escaping="yes"/>
                <xsl:value-of select="($nbsp)" disable-output-escaping="yes"/>
                <xsl:value-of select="($name)"/>
            </xsl:if>
        </li>

	</xsl:template>

</xsl:stylesheet>
