<?xml version="1.0"?>
<!-- in case of any change in xsl/xml file modify all connected xsl and xml files from this package  -->

<xsl:stylesheet version="1.1" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:saxon="http://icl.com/saxon" xmlns:graph="graph" xmlns:results="results" extension-element-prefixes="saxon">

    <!-- =================  print build errors menu ============================ -->
    
    <xsl:template name="display_build_errors_menu">
    
    <xsl:if test="($testing_process_problems) > 0">
    <xsl:if test="($codereview) > 0">
        <xsl:call-template name="display_linked_menu_item">
        <xsl:with-param name="text" select="$RES_PARAMETER_BUILD_ERRORS" />
        <xsl:with-param name="link" select="'#berr'" />
        </xsl:call-template>
   	</xsl:if> 
    </xsl:if>
    
    </xsl:template>

    <!-- =================  print build errors ============================ -->
    
    <xsl:template name="display_build_errors">
    
    <xsl:if test="($testing_process_problems) > 0">
    <br/>
    <xsl:call-template name="build_errors_header"/>
    <br/>    
    
    <xsl:call-template name="testing_process_problems"/>
    <br/>    
    </xsl:if>

    </xsl:template>    
    
    <!-- =================  print build errors header ============================ -->
    
    <xsl:template name="build_errors_header">
        <a name="berr"/>
        <table width="{$width}" cellpadding="0" cellspacing="0">
            <xsl:if test="($report_format_mode='pdf')">
               <xsl:attribute name="cols">100%</xsl:attribute>
            </xsl:if>
            <tr>
               <xsl:if test="not(($report_type) = ($email_report)) and not($report_format_mode='pdf')">
                  <td width="25%"></td>
               </xsl:if>
               <td align="center">
                   <div class="header"><xsl:value-of select="$RES_PARAMETER_BUILD_ERRORS"/></div>
               </td>
               <xsl:if test="not(($report_type) = ($email_report)) and not($report_format_mode='pdf')">
                  <td align="right" width="25%" valign="bottom">
                  <xsl:if test="($first_back_to_top = 'false')">
                    <xsl:call-template name="back_to_top"/>
                  </xsl:if>
                  <saxon:assign name="first_back_to_top">false</saxon:assign>
                  </td>
               </xsl:if>
            </tr>
        </table>
    </xsl:template>
   
    <!-- =================  testing process problems  ============================ -->
    
    <xsl:template name="testing_process_problems">
    <table width="{$width}" cellpadding='0' cellspacing='0' class="doubleborder" border="0" bordercolor="{$cs_bdrcolor}">
    <xsl:if test="($report_format_mode='pdf')">
        <xsl:attribute name="cols">100%</xsl:attribute>
    </xsl:if>
    <xsl:variable name="max_errors_to_show" select="300"/>
    <xsl:variable name="errors_count" select="0" saxon:assignable="yes"/>
    <xsl:variable name="tmp_tested_name" select="''" saxon:assignable="yes"/>
    <xsl:variable name="tmp_error_name" select="''" saxon:assignable="yes"/>		    
    
    <xsl:for-each select="/ResultsSession/*/TestingProcessProblems/*">
    <xsl:sort select="@tested"/>
	    
	    <xsl:if test="(($errors_count) &lt; ($max_errors_to_show))">
	        <xsl:if test="not($tmp_tested_name = @tested)">

			    <tr>
			    <td align="left" style="padding-left:5px">
			    <b><xsl:value-of select="(@tested)"/></b>
			    </td>
			    </tr>
	        </xsl:if>
            <tr><td align="left" style="padding-top:5px;padding-bottom:5px">
    	    <table width="100%" border="0" cellpadding="0" cellspacing="0">
            <xsl:if test="($report_format_mode='pdf')">
               <xsl:attribute name="cols">100%</xsl:attribute>
            </xsl:if>
            <xsl:for-each select="ErrorList/Error">
                <xsl:if test="not($tmp_error_name = @val)">         
                    <tr><td><pre style="margin:5px 5px 3px 5px;white-space:pre-wrap;"><xsl:value-of select="(@val)"/></pre></td></tr>
                    <saxon:assign name="errors_count" select="$errors_count + 1"/>
                </xsl:if>
                <saxon:assign name="tmp_error_name" select="@val"/>
            </xsl:for-each>
            </table>
            </td></tr>
		    
	        <saxon:assign name="tmp_tested_name" select="@tested"/>
   	        <saxon:assign name="tmp_error_name" select="''"/>
	    </xsl:if>
    
    </xsl:for-each>
    
    <xsl:if test="not(($errors_count) &lt; ($max_errors_to_show))">
    <tr><td><pre style="margin:5px 5px 3px 5px;white-space:pre-wrap;"><xsl:value-of select="$RES_PARAMETER_ELLIPSIS"/></pre></td></tr>
    </xsl:if>
    </table>
    </xsl:template>
    
</xsl:stylesheet>
